#include <plib.h>
#include <math.h>
#include "NU32.h"
#include <dsplib_dsp.h>
#include "fftc.h"
#include "Signal_and_FIR.h"
#include "NU32DSP.h"

#define FFT_SCALING (10)
#define FIR_COEFF_SCALE (10)
#define FIR_SIG_SCALE (10)

char msg[128];

int main(void)
{
    double fft_orig[SIGNAL_LENGTH], fft_fir[SIGNAL_LENGTH];
    double xfir[SIGNAL_LENGTH];
    int i = 0;
    
    NU32_Startup();
    NU32_Initialize();

    /* let's FIR original signal */
    NU32_FIR_1024(xfir, Signal, fir,
		  FIR_COEFF_SCALE, FIR_SIG_SCALE, FIR_LENGTH);
    
    /* FFT the original signal: */
    NU32_FFT_1024(fft_orig, Signal, FFT_SCALING);

    /* FFT the FIR signal */
    NU32_FFT_1024(fft_fir, xfir, FFT_SCALING);

    /* print the results to a terminal */
    for (i=0; i<SIGNAL_LENGTH; i++) {
	sprintf(NU32_RS232OutBuffer,
		"%12.6f %12.6f %12.6f %12.6f\r\n",
		Signal[i], xfir[i], fft_orig[i],
		fft_fir[i]);
	NU32_WriteUART1(NU32_RS232OutBuffer);
    }
    

    /* Just show the PIC is still running */
    while (1) {
	WriteCoreTimer(0);
	while (ReadCoreTimer() < 4000000);
	NU32LED1 = !NU32LED1;
	NU32LED2 = !NU32LED2;
    }
    return(0);
}
